//->!Macros.csc
// Produced by OvationPro at 9:48PM 7th April 2005
//
//


void main(void)
{
delallmacros();
defmacro2(0,"frame","{picktool(3,0)}","frame","Frame tool.|MLeft drag to draw frames of the specified shape.");
defmacro2(0,"line","{picktool(4,0)}","line","Line tool.|MLeft drag to draw lines of the specified shape.");
defmacro2(0,"pathedit","{picktool(11,0)}","pathedit","Path Edit Mode.|MIn path edit mode you may edit the shape of any objects drawn using straight or curved line segments. You cannot edit rectangles or ellipses without changing them to polygons first.");
defmacro2(0,"rotate","{picktool(2,0)}","rotate","Rotate tool.|MLeft drag on an object to rotate it.|MThe centre of rotation is indicated by a crosshair, which may be dragged to a new position.");
defmacro2(0,"link","{picktool(10,0)}","link","Link tool.|MLeft drag from one frame to another, to link them so that text flows between them.|MTo delete a link, left click on it, then press Delete.");
defmacro2(0,"crop","{picktool(13,0)}","crop","Crop tool.|MLeft drag on a picture to specify a rectangle that is scaled to fit the frame.");
defmacro2(0,"magnify","{picktool(9,0)}","magnify","Zoom tool.|MLeft click to increase the zoom at the pointer by 50%.|MRight click to decrease the zoom at the pointer by 50%.|MLeft drag to magnify a specified rectangle.");
defmacro2(0,"rectangle","{picktool(5,0)}","rect","Rectangle shape.|MIf this is selected, the Frame and Line tools will draw rectangles.|MHold down Shift while drawing, for perfect squares.");
defmacro2(0,"ellipse","{picktool(6,0)}","ellipse","Ellipse shape.|MIf this is selected, the Frame and Line tools will draw ellipses.|MHold down Shift while drawing, for perfect circles.");
defmacro2(0,"strseg","{picktool(8,0)}","strseg","Straight line segment shape.|MIf this is selected, the Frame and Line tools will draw straight line segments.");
defmacro2(0,"curseg","{picktool(7,0)}","curseg","Curved line segment shape.|MIf this is selected, the Frame and Line tools will draw curved line segments.");
defmacro2(0,"info","{openinfobox()}","info","Info.|MLeft click to display information about Ovation Pro.");
defmacro2(0,"new","{opennewbox()}","new","New.|MLeft click to create a new document with a specified format.");
defmacro2(0,"choices","{openchoicesbox()}","choices","Choices.|MLeft click to configure the application choices.");
defmacro2(0,"select","{picktool(1,0)}","select","Select tool.|MThis is the default tool used to select objects and edit text.");
defmacro2(4,"fileinfo","{openfileinfo()}","fileinfo","Document info.|MLeft click to display information about the current document.");
defmacro2(4,"saveas","{openfilesaveas()}","saveas","Save as.|MLeft click to save the current document using the Save As dialogue box.");
defmacro2(0,"save","{savedocument(\"\")}","save","Save.|MLeft click to save the current document without opening the save dialogue box.");
defmacro2(0,"export","{string s;if(export_name(s)) openexportbox(); else beep(0,0,0)}","export","Export story/picture.|MLeft click to save the current story, selected story or selected picture.");
defmacro2(0,"stylesheet","{saveasstylesheet()}","stylesheet","Save stylesheet.|MLeft click to save a stylesheet for the current document.");
defmacro2(0,"revert","{if(issaved() && ischanged() ) reverttosaved(); else beep(0,0,0)}","revert","Revert to saved.|MLeft click to restore the document to the most recently saved version.");
defmacro2(4,"printbox","{openprintbox()}","printbox","Print.|MLeft click to print the document using the Print dialogue box.");
defmacro2(0,"printdoc","{printdocument()}","printdoc","Print document.|MLeft click to print the document immediately, without opening the Print dialogue box.");
defmacro2(0,"mailmerge","{openprintmergebox()}","mailmerge","Mail merge.|MLeft click to specify a CSV file that is to be merged with the document when printed.");
defmacro2(12,"selectall","{selectall()}","selectall","Select all.|MLeft click to select all the text in the selected frame.|MIf there is no selected frame, select all objects.");
defmacro2(0,"clearsel","{if(nselected()) clearselection(); else beep(0,0,0)}","clear","Clear.|MLeft click to clear the current selection.");
defmacro2(4,"cut","{if(cancopy() && candelete()) cutselection(); else beep(0,0,0)}","cut","Cut.|MLeft click to delete the selected text, picture or object and place it on the clipboard.");
defmacro2(4,"copysel","{if(cancopy()) copyselection(); else beep(0,0,0)}","copy","Copy.|MLeft click to copy the selected text, picture or object onto the clipboard.");
defmacro2(4,"paste","{if(cliptype()>=0 && cliptype()!=4) pasteselection(); else beep(0,0,0)}","paste","Paste.|MLeft click to paste the contents of the clipboard back into the document.");
defmacro2(4,"deletesel","{if(candelete()) deleteselection(); else beep(0,0,0)}","delete","Delete.|MLeft click to delete the selected text, picture or object.");
defmacro2(4,"clipboard","{setclipboard(!getclipboard())}","clipboard","Clipboard.|MLeft click to view the clipboard.");
defmacro2(0,"embed","{if(cliptype()==0) embedobject(); else beep(0,0,0)}","embed","Embed object.|MLeft click to embed the object on the clipboard into the text at the current caret position.");
defmacro2(12,"undo","{if(canundo())undo();else beep(0,0,0)}","undo","Undo.|MLeft click to undo the last operation performed.");
defmacro2(4,"redo","{if(canredo())redo();else beep(0,0,0)}","redo","Redo.|MLeft click to redo the last undo operation performed.");
defmacro2(0,"find","{openfindbox()}","find","Find.|MLeft click to search a story or document for a string, optionally replacing the found string with another string.");
defmacro2(0,"newview","{newview(0)}","newview","New view.|MLeft click to open a new view on the current document.");
defmacro2(0,"view","{openviewbox()}","view","View options.|MLeft click to open the view options dialogue box.");
defmacro2(0,"toolbox","{settools(!gettools())}","toolbox","Toolbox|MLeft click to show/hide the toolbox.");
defmacro2(0,"infopal","{setinfopal(!getinfopal())}","infopal","Info palette.|MLeft click to show/hide the info palette.");
defmacro2(12,"rulers","{setrulers(!getrulers())}","rulers","Rulers.|MLeft click to show/hide the page rulers.");
defmacro2(0,"pasteboard","{setpasteboard(!getpasteboard())}","pasteboard","Pasteboard.|MLeft click to show/hide the pasteboard.");
defmacro2(0,"pictures","{setpictures(!getpictures())}","pictures","Pictures|MLeft click to show/hide pictures.");
defmacro2(4,"guidelines","{setguides(!getguides())}","guidelines","Guidelines.|MLeft click to show/hide guidelines.");
defmacro2(0,"printmargin","{setmargins(!getmargins())}","printmargin","Print margins.|MLeft click to show/hide the print margins.");
defmacro2(0,"facingpages","{setfacingpages(!getfacingpages())}","facingpages","Facing pages.|MLeft click to enable/disable facing pages.");
defmacro2(0,"invisibles","{setinvisibles(!getinvisibles())}","invisibles","Invisibles.|MLeft click to show/hide invisibles.");
defmacro2(0,"showerrors","{setspellerrors(!getspellerrors())}","showerrors","Show spelling errors.|MLeft click to show/hide spelling errors.");
defmacro2(0,"gridbox","{opengridbox()}","gridbox","Grid box.|MLeft click to open the Grid dialogue box.");
defmacro2(4,"grid","{setgrid(!getgrid());setgridlock(getgrid())}","grid","Grid.|MLeft click to enable/disable the grid and grid lock.");
defmacro2(4,"zoom","{openzoombox()}","zoom","Document magnification.|MLeft click to open the Zoom dialogue box.");
defmacro2(0,"75%","{setzoom(ZOOM75,0,0)}","","75% zoom.|MLeft click to set document zoom to 75%.");
defmacro2(0,"125%","{setzoom(ZOOMDEF,125,100)}","","125% zoom.|MLeft click to set document zoom to 125%.");
defmacro2(0,"fitwindow","{setzoom(ZOOMFIT,0,0)}","fitwindow","Fit window.|MLeft click to set the document zoom so that an entire page (or pair of pages) fits in the document window.");
defmacro2(0,"fitscreen","{setzoom(ZOOMSCR,0,0)}","fitscreen","Fit screen.|MLeft click to set the document zoom so that an entire page (or pair of pages) fits on the screen.");
defmacro2(12,"objcontents","{openobjectcontentsbox()}","objcontents","Modify text/picture.|MLeft click to modify the text/picture contents of the selected frame.");
defmacro2(0,"font","{opentextfont()}","font","Font menu.|MLeft click to display the Font menu.");
defmacro2(0,"Corpus","{string s;int i=0;while(getfontname(i++,s)) if(s==\"Corpus\") {caretcontext();setfont(i-1);}}","","Corpus font.|MLeft click to apply Corpus font to the selected text or to the caret.");
defmacro2(0,"Courier","{string s;int i=0;while(getfontname(i++,s)) if(s==\"Courier New\") {caretcontext();setfont(i-1);}}","","Courier font.|MLeft click to apply Courier font to the selected text or to the caret.");
defmacro2(0,"size","{open_menu(size_menu(1))}","size","Size menu.|MLeft click to display the type Size menu.");
defmacro2(0,"13pt","{setfontsize(13*1000)}","","13pt type size.|MLeft click to apply a size change to the selected text or to the caret, to 13pt.");
defmacro2(0,"effect","{open_menu(effx_menu(1))}","effect","Effect menu.|MLeft click to display a menu of effects that can be applied to the selected text or to the caret.");
defmacro2(0,"normal","{seteffect(NORMAL)}","normal","Normal.|MLeft click to remove all effects from the the selected text or from the caret.");
defmacro2(0,"bold","{seteffect(BOLD)}","bold","Bold.|MLeft click to apply the bold variant of the current font to the selected text or to the caret.");
defmacro2(0,"italic","{seteffect(ITALIC)}","italic","Italic.|MLeft click to apply the italic variant of the current font to the selected text or to the caret.");
defmacro2(0,"underline","{seteffect(UNDERLINE)}","underline","Underline.|MLeft click to apply underline to the selected text or to the caret.");
defmacro2(0,"reverse","{seteffect(REVERSE)}","reverse","Reverse.|MLeft click to swap text foreground and background colours for the selected text or at the caret.");
defmacro2(0,"superscript","{seteffect(SUPERSCRIPT)}","superscript","Superscript.|MLeft click to apply superscript to the selected text or to the caret.");
defmacro2(0,"subscript","{seteffect(SUBSCRIPT)}","subscript","Subscript.|MLeft click to apply subscript to the selected text or to the caret.");
defmacro2(4,"textcolour","{if(activetype(TEXTFRAME)>1) opencolourbox();else beep(0,0,0)}","textcolour","Text colour.|MLeft click to open the colour picker, which can be used to apply colour to the selected text or to the caret.");
defmacro2(0,"vshiftup","{setbaseshift(getbaseshift() + 0x10000/20)}","vshiftup","Vertical shift up.|MLeft click to shift the selected text up in 5% steps.");
defmacro2(0,"vshiftdown","{setbaseshift(getbaseshift() - 0x10000/20)}","vshiftdown","Vertival shift down.|MLeft click to shift the selected text down in 5% steps.");
defmacro2(4,"format","{if(activetype(TEXTFRAME)>1) openformatbox();else beep(0,0,0)}","format","Format.|MLeft click to apply a wide range of formatting options to the current or selected paragraphs.");
defmacro2(0,"align","{open_menu(align_menu(1))}","align","Align.|MLeft click to display the paragraph Alignment menu.");
defmacro2(0,"left","{setalign(LEFT)}","left","Left align.|MLeft click to left-align the current or selected paragraphs.");
defmacro2(0,"centre","{setalign(CENTRE)}","centre","Centre align..|MLeft click to centre-align the current or selected paragraphs.");
defmacro2(0,"right","{setalign(RIGHT)}","right","Right align.|MLeft click to right-align the current or selected paragraphs.");
defmacro2(0,"justify","{setalign(JUSTIFY)}","justify","Justify paragraph.|MLeft click to justify the current or selected paragraphs.");
defmacro2(0,"singlespc","{setleading(\"20%\")}","singlespc","Single space.|MLeft click to apply 'single spacing' (20% leading) to the current or selected paragraphs.");
defmacro2(0,"doublespc","{setleading(\"100%\")}","doublespc","Double space.|MLeft click to apply 'double spacing' (100% leading) to the current or selected paragraphs.");
defmacro2(0,"14ptL","{setleading(\"14pt\")}","","14pt leading.|MLeft click to apply 14pt absolute leading to the current or selected paragraphs.");
defmacro2(4,"tabs","{if(activetype(TEXTFRAME)>1) opentabsbox();else beep(0,0,0)}","tabs","Tab ruler.|MLeft click to set tab and indent positions for the current or selected paragraphs.");
defmacro2(0,"style","{open_menu(style_menu(1))}","style","Style menu.|MLeft click to display the defined Style menu.");
defmacro2(0,"editstyle","{openstylebox(0)}","editstyle","Edit style.|MLeft click to create, edit, rename and delete styles.");
defmacro2(0,"Style#1","{string s;int i=0;while(getuserstyle(i++,s,1)) if(s==\"Style#1\") addstyle(i-1)}","","Style#1.|MLeft click to apply the style named 'Style#1'.");
defmacro2(0,"clearall","{remove_styles(0,0)}","clearall","Remove all styles.|MLeft click to remove all styles and effects from the current or selected paragraphs.");
defmacro2(0,"cleareffects","{cleareffects(0)}","cleareffects","Remove all effects.|MLeft click to remove all effects from the current or selected paragraphs.");
defmacro2(12,"modifyobject","{if(canmodify()) openobjectbox(); else beep(0,0,0)}","modifyobject","Modify object.|MLeft click to modify the properties of the current object or selection.");
defmacro2(4,"border","{if(canmodify()) openborderbox();else beep(0,0,0)}","border","Border.|MLeft click to apply a border to the current frame or selection.");
defmacro2(12,"chkword","{checkword()}","checkword","Spellcheck word.|MLeft click to spellcheck the current word.");
defmacro2(4,"chkstory","{checkstory(0)}","checkstory","Spellcheck story.|MLeft click to spellcheck the current story from the start.");
defmacro2(0,"textflow","{if(canmodify()) opentextflowbox();else beep(0,0,0)}","textflow","Text flow.|MLeft click to control how text flows around the current object or selection.");
defmacro2(0,"duplicate","{if(canduplicate()) openduplicatebox(); else beep(0,0,0)}","duplicate","Duplicate.|MLeft click to duplicate the current object or selection.");
defmacro2(0,"shape","{if(canshape()) openshapebox(); else beep(0,0,0)}","shape","Shape.|MLeft click to change the shape of the current object or selection.");
defmacro2(0,"front","{if(cangofront()) objectfront();else beep(0,0,0)}","front","Front.|MLeft click to bring the current object or selection to the front.");
defmacro2(0,"back","{if(cangoback()) objectback();else beep(0,0,0)}","back","Back.|MLeft click to send the current object or selection to the back.");
defmacro2(0,"forward","{objectforward(1)}","forward","Forward.|MLeft click to bring the current object or selection forward one level.");
defmacro2(0,"backward","{objectbackward(1)}","backward","Backward.|MLeft click to send the current object or selection back one level.");
defmacro2(0,"group","{if(cangroup()) groupselection(); else ungroupselection()}","group","Group/ungroup.|MLeft click to group the selected objects or ungroup the current selection.");
defmacro2(0,"local","{if(canmakelocal()) makeselectionlocal();else if(canmakemaster()) makeselectionmaster()}","local","Make local/Make master.|MLeft click to make the selected master object, local.|MIf the selected object is a localised master object, then it is changed back to a master object.");
defmacro2(0,"snap","{snaptogrid()}","snap","Snap to grid.|MLeft click to snap the top left corner of the current object or selection, to the nearest grid point.");
defmacro2(0,"masterpages","{newview(1)}","masterpages","Master pages.|MLeft click to open the master pages for the current chapter.");
defmacro2(0,"newchapter","{opennewchapterbox(1)}","newchapter","New chapter.|MLeft click to create a new chapter that is inserted after the current chapter.");
defmacro2(0,"pageguides","{if(ismasterview()) openpageguidebox(); else beep(0,0,0)}","pageguides","Page guidelines.|MLeft click to edit the page guidelines for the current master page.");
defmacro2(0,"modchapter","{openmodchapterbox()}","modchapter","Modify chapter.|MLeft click to modify the properties of the current chapter.");
defmacro2(0,"delchapter","{deletechapter()}","delchapter","Delete chapter.|MLeft click to delete the current chapter.");
defmacro2(0,"insertpage","{openinspagebox()}","insertpage","Insert page.|MLeft click to insert pages before or after the current page.");
defmacro2(0,"deletepage","{opendelpagebox()}","deletepage","Delete page.|MLeft click to delete a range of pages.");
defmacro2(0,"goto","{opengotopagebox()}","goto","Goto page.|MLeft click to go to a specified chapter and page.");
defmacro2(0,"chkdoc","{checkdocument()}","checkdoc","Spellcheck document.|MLeft click to spellcheck all the stories in the current document.");
defmacro2(0,"chkcaret","{checkstory(1)}","checkcaret","spellcheck from caret.|MLeft click to spellcheck the current story, starting from the caret.");
defmacro2(0,"checktype","{setcheck(!getcheck())}","checktype","Check as you type.|MLeft click to enable/disable the feature where words are spellchecked as you type them.");
defmacro2(0,"dictionary","{opendictionarybox()}","dictionary","Dictionary.|MLeft click to load, remove, create, edit and delete spellcheck dictionaries.");
defmacro2(0,"characters","{opencharsbox()}","characters","Characters.|MLeft click to insert any character chosen from a display of the full character set.");
defmacro2(0,"insertmenu","{open_menu(insert_menu(1))}","insertmenu","Insert menu.|MLeft click to display the Insert menu.");
defmacro2(0,"chapternumb","{ChapterNumber}","chapternumb","Chapter number.|MLeft click to insert the current chapter number at the caret.");
defmacro2(0,"pagenumb","{PageNumber}","pagenumb","Page number.|MLeft click to insert the current page number at the caret.");
defmacro2(0,"current date","{'C_D}","date","Date.|MLeft click to insert the date at the caret.");
defmacro2(0,"active date","{ActiveDate}","activedate","Active date.|MLeft click to insert the active date at the caret.|MThe active date is updated each time the document is loaded.");
defmacro2(0,"current time","{Time}","time","Time.|MLeft click to insert the time at the caret.");
defmacro2(0,"new page","{NewPage}","newpage","New page.|MLeft click to insert a page break at the caret.");
defmacro2(0,"new line","{NewLine}","newline","New line.|MLeft click to start a new line (but not a new paragraph).");
defmacro2(0,"hard space","{HardSpace}","hardspace","Hard space.|MLeft click to insert a non-breaking space that is never split at the end of lines.");
defmacro2(0,"hard hyphen","{HardHyphen}","hardhyphen","Hard hyphen.|MLeft click to insert a non-breaking hyphen that is never split at the end of lines.");
defmacro2(0,"soft hyphen","{SoftHyphen}","softhyphen","Soft hyphen.|MLeft click to insert a soft (discretionary) hyphen that only appears when it is needed to split a word at the end of a line.");
defmacro2(0,"mergetag","{openmergebox()}","mergetag","Merge tag.|MLeft click to insert a field that is to be merged by the Mail Merge facility.");
defmacro2(0,"preferences","{openprefbox()}","preferences","Preferences.|MLeft click to configure the document preferences");
defmacro2(0,"editcolour","{openeditcolourbox(0)}","editcolour","Edit colour.|MLeft click to create, edit, rename and delete user defined colours.");
defmacro2(0,"macros","{openmacrobox()}","macros","Macros.|MLeft click to create, edit and delete 'button' and 'key' macros.");
defmacro2(0,"swapcase","{'CS_S}","swapcase","Swap case.|MLeft click to swap the case of the selected text.");
defmacro2(0,"thesaurus","{'C_T}","thesaurus","Thesaurus.|MLeft click to look up the current word in DeskTop Thesaurus (which must be loaded).");
defmacro(2,"nextclip","{setcurrentclipboard(getcurrentclipboard()+1)}","");
defmacro(2,"prevclip","{setcurrentclipboard(getcurrentclipboard()-1)}","");
defmacro(2,"bigcopy","{nextclip}{copyselection()}","");
defmacro(2,"bigpaste","{pasteselection()}{prevclip}","");
defmacro(1,"CS_H","{objectbackward(1)}","");
defmacro(1,"CS_U","{objectforward(1)}","");
defmacro(1,"C_Insert","{filename}","");
defmacro(1,"S_Insert","{filepath}","");
defmacro(1,"CS_F1","{if(activetype(PICTFRAME)) openpictureinfobox(); else openfileinfo();}","");
defmacro(1,"CS_W","{int b; if(activetype(TEXTFRAME)) {b = bmcreate(\"b\"); setbmtocaret(b); bmmove(b, 0, 1); type(\"{C_CRight}\"); setzonetobm(b); bmdelete(b);}}","");
}

