/*->h.colsep */



#define CSPR_STARTJOB   0x1
#define CSPR_STARTSEP   0x2
#define CSPR_ENDSEP     0x3
#define CSPR_ENDJOB     0x4
#define CSPR_STARTCOPY  0x5
#define CSPR_ENDCOPY    0x6


#define CSPX_START      0x1
#define CSPX_END        0x2



#define DSTPROCESS      0x1500



extern int        colsepactive(void);

extern int        cscurrentplate(void * prjob);

extern os_error * opencolsep(viewstr * view,dboxstr * dbox);
extern os_error * colseparationprint(void * prjob,int code);
extern os_error * colseparationpict(viewredrawstr * v,int pict,
                                                      int process,int code);

extern os_error * xrgb2hsv(viewstr * view,filestr * file,
                                          quadstr * rgb,quadstr * hsv);
extern os_error * xhsv2rgb(viewstr * view,filestr * file,
                                          quadstr * hsv,quadstr * rgb);
extern os_error * xrgb2cmyk(viewstr * view,filestr * file,
                                           quadstr * rgb,quadstr * cmyk);
extern os_error * xcmyk2rgb(viewstr * view,filestr * file,
                                           quadstr * cmyk,quadstr * rgb);

extern os_error * csprocess(viewstr * view,void * d,
                                           void * s,
                                           int    size,
                                           int    dtype,
                                           int    stype);


extern os_error * xcconv(viewstr * view,filestr * file,
                         quadstr * s,int stype,quadstr * d,int dtype);


extern os_error * setprocess(int processkey,viewstr * view,processstr * pr);

extern os_error * deleteprocess(int processkey,filestr * file);
extern os_error * copyprocess(int skey,int * dkey,filestr * file);
extern os_error * copyprocessm(int * dkey,filestr * dfile,
                               int skey,filestr * sfile,int mode);

extern os_error * dswriteprocess(int processkey,buffer * bf,filestr * file);
extern os_error * defltprocess(int * key,filestr * file);
extern int        cmpprocess(int key1,filestr * file1,
                             int key2,filestr * file2);


extern int modelgetpal(viewstr * view,filestr * file,int model,quadstr * quad);
extern int modelgetpalnaive(viewstr * view,filestr * file,
                                                     int model,quadstr * quad);

extern int colourgetpal(colourstr * cs,viewstr * view,filestr * file);


extern os_error * xcmyk2rgb3232(viewstr * view,int * s,int * d,int size);
extern os_error * xcmyk2bgr3232(viewstr * view,int * s,int * d,int size);
extern os_error * csgetspotinfo(viewstr * view,int * key,int * spotmode);



typedef os_error * (*closescreenfn)(int process,int code);

extern os_error * openscreen(int process,filestr * file,
                             dboxstr * parent,closescreenfn csfn);




