/*->h.ole */



typedef os_error * (*olesavefn)(char * name,void * file,void * oledata);
typedef os_error * (*oleloadfn)(char * name,int ftype,void * file,
                                                        void * oledata);




typedef struct oledatastr
{
 int           type;       /* data type */
 void        * file;
 int           user1;
 int           user2;
 int           page;
 int           section;
 olesavefn     save;
 oleloadfn     load;
 int           sh;         /* scrap file handle */
 int           task;
 int           session;
 int           loadaddress;
 int           execaddress;
 int           handle;
 int           dwindow;
 int           dx;
 int           dy;
 int           timeout;
 char        * path;

} oledatastr;





extern os_error * oleobject(oledatastr * data);
extern void       olesetup(int fp);
extern os_error * olefinit(void);
extern os_error * oleinit(void);


