/*->c.pxchoices */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"

#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "bf.h"
#include "fsx.h"
#include "timex.h"
#include "bits.h"
#include "conf.h"
#include "dbhi.h"


#include "str.h"

#include "obj.h"

#include "units.h"
#include "reslink.h"

#include "view.h"
#include "viewo.h"


#include "dbchoices.h"

#include "pxstr.h"

#include "dbpixref.h"
#include "pxcache.h"

#include "pxchoices.h"



static int ximportscale;
       int defimportscale;

static int xaspectlock;

static int xautoscale;

static int xcentrelock;

static int xframeinset;

static int xerror;
       int defpixerror;


static int xpxcachemax;

static int xpxproxylimit;
       int pxproxylimit;

static int xpxdoproxylimit;
       int pxdoproxylimit;

static int xpxreflimit;
       int pxreflimit;

static int xpxdoreflimit;
       int pxdoreflimit;

static pxproxystr xpxdefproxy;

       int pxfontcheck;
static int xpxfontcheck;


static os_error * chclose(int code)
{
 if(code==DBOK || code==DBAPPLY)
 {
  defimportscale=ximportscale;
  defltpicturedata.pd.fixaspect=xaspectlock;
  defltpicturedata.pd.autoscale=xautoscale;
  defltpicturedata.pd.lockmode=xcentrelock;
  defltpictdata.i=xframeinset;
  defpixerror=xerror;

  pxcachemax=xpxcachemax;
  pxproxylimit=xpxproxylimit;
  pxdoproxylimit=xpxdoproxylimit;
  pxreflimit=xpxreflimit;
  pxdoreflimit=xpxdoreflimit;
  pxdefproxy=xpxdefproxy;
  pxfontcheck=xpxfontcheck;
 }

 return(NULL);
}


static os_error * chsave(buffer * bf)
{
 os_error * err;

 err=bf_printfeol(bf,"picturechoices(%d,%d,%d,%d,%d,%d);",
       defimportscale,defltpicturedata.pd.fixaspect,
                      defltpicturedata.pd.autoscale,
                      defltpicturedata.pd.lockmode,
                      defltpictdata.i,defpixerror);

 if(!err) err=bf_printfeol(bf,"picturechoices2(%d,%d,%d,%d,%d);",
                                            pxcachemax,
                                            pxdoproxylimit,pxproxylimit,
                                            pxdoreflimit,pxreflimit);

 if(!err) err=bf_printfeol(bf,"picturechoices3(%d,%d,%d,%d);",
                                        pxdefproxy.dither,
                                        pxdefproxy.scale,
                                        pxdefproxy.bpp,
                                        pxfontcheck);

 return(err);
}


void picturechoices(int fp)
{
 defimportscale=stack[fp];
 defltpicturedata.pd.fixaspect=stack[fp+1];
 defltpicturedata.pd.autoscale=stack[fp+2];
 defltpicturedata.pd.lockmode=stack[fp+3];
 defltpictdata.i=stack[fp+4];
 defpixerror=stack[fp+5];
}


void picturechoices2(int fp)
{
 pxcachemax=stack[fp];
 pxdoproxylimit=stack[fp+1];
 pxproxylimit=stack[fp+2];
 pxdoreflimit=stack[fp+3];
 pxreflimit=stack[fp+4];
}


void picturechoices3(int fp)
{
 pxdefproxy.dither=stack[fp];
 pxdefproxy.scale=stack[fp+1];
 pxdefproxy.bpp=stack[fp+2];
 pxfontcheck=stack[fp+3];
}




static os_error * chproxyfn(pxproxystr * proxy)
{
 xpxdefproxy=*proxy;
 return(NULL);
}




static os_error * chicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==25) err=openproxychoice(&xpxdefproxy,chproxyfn,
                                               choicebox,&dbchoicestack);

 return(err);

 USE(handle);
 USE(userhandle);
}







static os_error * outd(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,2,0));
 return(NULL);
}


static os_error * ind(int * value,char * string)
{
 return(stringtonumberxdp(string,value,5,0));
}



static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,MILIMS));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,MILIMS));
}




static os_error * outm(int value,char * string)
{
 strcpy(string,memstring(value));
 return(NULL);
}





static dbiconstr chicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    6, &xaspectlock, DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
    7, &xautoscale,  DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
    5, &xcentrelock, DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,

   52, &xframeinset, DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
    4, &xerror,      DBWRITE,  0,     0,    -1, -1, -1, -1,  ind, outd,
    9, &ximportscale,DBWRITE,  0,     0,    -1, -1, -1, -1,readpc,writepc,

   14, &xpxcachemax,  DBTEXT,   0,     0,    -1, -1, -1, -1, NULL, outm,
   16, &xpxcachemax,  DBINC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,
   15, &xpxcachemax,  DBDEC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,

   22, &xpxproxylimit,DBTEXT,   0,     0,    -1, -1, -1, -1, NULL, outm,
   24, &xpxproxylimit,DBINC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,
   23, &xpxproxylimit,DBDEC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,

   18, &xpxreflimit,  DBTEXT,   0,     0,    -1, -1, -1, -1, NULL, outm,
   20, &xpxreflimit,  DBINC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,
   19, &xpxreflimit,  DBDEC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,

   17, &xpxdoreflimit,DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
   21, &xpxdoproxylimit,DBTOGGLE,0,   0,      1,  F1, 0, 0,  NULL,    0,

   26, &xpxfontcheck, DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static os_error * chopen(void)
{
 ximportscale=defimportscale;
 xaspectlock=defltpicturedata.pd.fixaspect;
 xautoscale=defltpicturedata.pd.autoscale;
 xcentrelock=defltpicturedata.pd.lockmode;
 xframeinset=defltpictdata.i;
 xerror=defpixerror;


 xpxcachemax=pxcachemax;
 xpxproxylimit=pxproxylimit;
 xpxdoproxylimit=pxdoproxylimit;
 xpxreflimit=pxreflimit;
 xpxdoreflimit=pxdoreflimit;
 xpxdefproxy=pxdefproxy;
 xpxfontcheck=pxfontcheck;

 return(NULL);
}


static dboxstr chbox=
{
 0,
 TCHPICT,
 DBPANE,
 0,
 NULL,
 chicon,
 NULL,
 NULL,
 chicondefs,
 0,
 0
};


static subchoicestr ch=
{
 NULL,

 &chbox,

 "ch_picture",
 "{CHF0}",

 chsave,
 chclose,
 NULL,
 chopen,
 NULL,
};



/*****************************************************************************/

os_error * dbpxinit(void)
{
 return(choicesadd(&ch));
}


