/*->$.Q.!OvnPro.AutoRun.!Menus */

void create_main_menu(void)
{
 main_handle=create_menu("{MM00}");

 addentry_menu(main_handle,"","","file_menu","","{MM01}");
 addentry_menu(main_handle,"","","edit_menu","","{MM02}");
 addentry_menu(main_handle,"","","view_menu","","{MM03}");
 addentry_menu(main_handle,"","","content_menu","","{MM04}");
 addentry_menu(main_handle,"","","style_menu","","{MM05}");
 addentry_menu(main_handle,"","","object_menu","","{MM06}");
 addentry_menu(main_handle,"","","page_menu","","{MM07}");
 addentry_menu(main_handle,"","","misc_menu","","{MM08}");
 addentry_menu(main_handle,"","","info_menu","","{MM09}");

 addeventhandler(0xF,0xF,"mainmenu_event");
 addeventhandler(0x11,0x11,"mainmenu_event");
 addeventhandler(0x502,0x502,"mainmenu_event");
 addeventhandler(0x503,0x503,"mainmenu_event");
}

/****************************************************************/

void create_file_menu(void)
{
 file_handle=create_menu("{FM00}");

 addentry_menu(file_handle,"opennewbox","","","C_N","{FM11}");
 addentry_menu(file_handle,"openfileopen","","","C_O","{FM09}");
 addentry_menu(file_handle,"file_entry","file_flags","","","{FM01}");
 addentry_menu(file_handle,"file_entry","file_flags","","C_S","{FM10}");
 addentry_menu(file_handle,"openfilesaveas","","","","{FM02}");
 addentry_menu(file_handle,"openexportbox","file_flags","","","{FM03}");
 addentry_menu(file_handle,"openimportbox","file_flags","","","{FM12}"); 
 addentry_menu(file_handle,"saveasstylesheet","","","","{FM04}");
 addentry_menu(file_handle,"reverttosaved","file_flags","","","{FM05}");
 addentry_menu(file_handle,"openprintbox","","","C_P","{FM06}");
 addentry_menu(file_handle,"openprintmergebox","file_flags","","","{FM07}");
 addentry_menu(file_handle,"saveasdefault","","","","{FM08}");
 addentry_menu(file_handle,"quit","","","","{IBM05}");

}


/****************************************************************/

void create_edit_menu(void)
{
 edit_handle=create_menu("{EM00}");

 addentry_menu(edit_handle,"undo","edit_flags","","C_Z","{EM01}");
 addentry_menu(edit_handle,"redo","edit_flags","","C_Y","{EM02}");
 addentry_menu(edit_handle,"cutselection","edit_flags","","C_X","{EM03}");
 addentry_menu(edit_handle,"copyselection","edit_flags","","C_C","{EM04}");
 addentry_menu(edit_handle,"pasteselection","edit_flags","","C_V","{EM05}");
 addentry_menu(edit_handle,"deleteselection","edit_flags","","C_K","{EM06}");
 addentry_menu(edit_handle,"embedobject","edit_flags","","","{EM07}");
 addentry_menu(edit_handle,"selectall","","","C_A","{EM08}");
 addentry_menu(edit_handle,"clearselection","edit_flags","","","{EM09}");
 addentry_menu(edit_handle,"openfindbox","edit_flags","","C_F","{EM10}");
 addentry_menu(edit_handle,"findnext","edit_flags","","F3","{EM11}");
}

/****************************************************************/

void create_view_menu(void)
{
 view_handle=create_menu("{VM00}");

 addentry_menu(view_handle,"newview","view_flags","","","{VM01}");
 addentry_menu(view_handle,"openviewbox","","","CS_O","{VM02}");
 addentry_menu(view_handle,"opengridbox","","","CS_G","{VM03}");
 addentry_menu(view_handle,"openzoombox","","","CS_Z","{VM04}");
 addentry_menu(view_handle,"view_entry","","","CS_B","{IBM03}");
}

/****************************************************************/

void create_text_menu(void)
{
 text_handle=create_menu("{TM00}");

 addentry_menu(text_handle,"openobjectcontentsbox","text_flags","","F6","{TM01}");
 addentry_menu(text_handle,"opentextfont","text_flags","","CS_F","{TM02}");
 addentry_menu(text_handle,"","text_flags","size_menu","","{TM03}");
 addentry_menu(text_handle,"","text_flags","effx_menu","","{TM04}");
 addentry_menu(text_handle,"opencolourbox","text_flags","","","{TM05}");
 addentry_menu(text_handle,"openformatbox","text_flags","","","{TM06}");
 addentry_menu(text_handle,"","text_flags","align_menu","","{TM07}");
 addentry_menu(text_handle,"","text_flags","lead_menu","","{TM08}");
 addentry_menu(text_handle,"opentabsbox","text_flags","","C_TAB","{TM09}");
 addentry_menu(text_handle,"","text_flags","remeffx_menu","","{TM11}");
// addentry_menu(text_handle,"openrulesbox","text_flags","","C_U","{TM10}");
}

/****************************************************************/

void create_case_menu(void)
{
 case_handle=create_menu("{CM00}");

 addentry_menu(case_handle,"case_entry","case_flags","","","{CM01}");
 addentry_menu(case_handle,"case_entry","case_flags","","","{CM02}");
 addentry_menu(case_handle,"case_entry","case_flags","","","{CM03}");
 addentry_menu(case_handle,"case_entry","case_flags","","","{CM04}");
}

/****************************************************************/

void create_tint_menu(void)
{
 int i;

 tint_handle=create_menu("{TNM00}");

 for(i=10;i<=100;i=i+10)
  addentry_menu(tint_handle,"tint_entry","tint_flags","","",itos(i));
// addentry_menu(tint_handle,"tint_entry","tint_flags","","","");
}

/****************************************************************/

void create_ulinewidth_menu(void)
{
 ulinewidth_handle=create_menu("{UWM00}");

 addentry_menu(ulinewidth_handle,"ulinewidth_entry","ulinewidth_flags","","","{UWM01}");
 addentry_menu(ulinewidth_handle,"ulinewidth_entry","ulinewidth_flags","","","{UWM02}");
 addentry_menu(ulinewidth_handle,"ulinewidth_entry","ulinewidth_flags","","","{UWM03}");
// addentry_menu(ulinewidth_handle,"ulinewidth_entry","ulinewidth_flags","","","");
}

/****************************************************************/

void create_size_menu(void)
{
 size_handle=create_menu("{SZM00}");

 addentry_menu(size_handle,"size_entry","size_flags","","","");usize0=8000;
 addentry_menu(size_handle,"size_entry","size_flags","","","");usize1=10000;
 addentry_menu(size_handle,"size_entry","size_flags","","","");usize2=12000;
 addentry_menu(size_handle,"size_entry","size_flags","","","");usize3=14000;
 addentry_menu(size_handle,"size_entry","size_flags","","","");usize4=18000;
 addentry_menu(size_handle,"size_entry","size_flags","","","");usize5=24000;
 addentry_menu(size_handle,"size_entry","size_flags","","","");usize6=36000;
// addentry_menu(size_handle,"size_entry","size_flags","","","");
}

/****************************************************************/

void create_effx_menu(void)
{
 effx_handle=create_menu("{EFM00}");

 addentry_menu(effx_handle,"effx_entry","effx_flags","","CS_N","{EFM01}");
 addentry_menu(effx_handle,"effx_entry","effx_flags","","C_B","{EFM02}");
 addentry_menu(effx_handle,"effx_entry","effx_flags","","C_I","{EFM03}");
 addentry_menu(effx_handle,"effx_entry","effx_flags","","C_U","{EFM04}");
 addentry_menu(effx_handle,"effx_entry","effx_flags","","CS_V","{EFM05}");
 addentry_menu(effx_handle,"effx_entry","effx_flags","","CS_=","{EFM06}");
 addentry_menu(effx_handle,"effx_entry","effx_flags","","C_=","{EFM07}");
}

/****************************************************************/

void create_bullet_menu(void)
{
 bullet_handle=create_menu("{BLM00}");

 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM01}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM02}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM03}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM04}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM05}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM09}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM10}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM06}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM07}");
 addentry_menu(bullet_handle,"bullet_entry","bullet_flags","","","{BLM08}");
}

/****************************************************************/

void create_align_menu(void)
{
 align_handle=create_menu("{AM00}");

 addentry_menu(align_handle,"align_entry","align_flags","","C_L","{AM01}");
 addentry_menu(align_handle,"align_entry","align_flags","","C_E","{AM02}");
 addentry_menu(align_handle,"align_entry","align_flags","","C_R","{AM03}");
 addentry_menu(align_handle,"align_entry","align_flags","","C_J","{AM04}");
}

/****************************************************************/

void create_lead_menu(void)
{
 lead_handle=create_menu("{LM00}");

 addentry_menu(lead_handle,"lead_entry","lead_flags","","","{LM01}");
 addentry_menu(lead_handle,"lead_entry","lead_flags","","","{LM02}");
// addentry_menu(lead_handle,"lead_entry","lead_flags","","","");
}

/****************************************************************/

void create_rulewidth_menu(void)
{
 rulewidth_handle=create_menu("{RWM00}");

 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");urwidth0=0;
 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");urwidth1=709;
 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");urwidth2=1417;
 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");urwidth3=2834;
 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");urwidth4=5669;
 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");urwidth5=11338;
 addentry_menu(rulewidth_handle,"rulewidth_entry","rulewidth_flags","","","");
}

/****************************************************************/

void create_picture_menu(void)
{
 picture_handle=create_menu("{PM00}");

 addentry_menu(picture_handle,"openobjectcontentsbox","","","F6","{PM01}");
 addentry_menu(picture_handle,"openpictureinfobox","","","","{PM02}");
 addentry_menu(picture_handle,"openpicturereferencebox","","","","{PM03}");
 addentry_menu(picture_handle,"openproxybox","","","","{PM04}");
}

/****************************************************************/

void create_scope_menu(void)
{
 scope_handle=create_menu("{SCM00}");

 addentry_menu(scope_handle,"scope_entry","scope_flags","","","{SCM01}");
 addentry_menu(scope_handle,"scope_entry","scope_flags","","","{SCM02}");
 addentry_menu(scope_handle,"scope_entry","scope_flags","","","{SCM03}");
 addentry_menu(scope_handle,"scope_entry","scope_flags","","","{SCM04}");
 addentry_menu(scope_handle,"scope_entry","scope_flags","","","{SCM05}");
}

/****************************************************************/

void create_object_menu(void)
{
 object_handle=create_menu("{OM00}");

 addentry_menu(object_handle,"openobjectbox","object_flags","","F7","{OM01}");
 addentry_menu(object_handle,"openborderbox","object_flags","","","{OM02}");
 addentry_menu(object_handle,"opentextflowbox","object_flags","","CS_T","{OM03}");
 addentry_menu(object_handle,"openshapebox","object_flags","","C_H","{OM04}");
 addentry_menu(object_handle,"object_entry","object_flags","","CS_D","{OM05}");
 addentry_menu(object_handle,"object_entry","object_flags","","CS_K","{OM06}");
 addentry_menu(object_handle,"object_entry","object_flags","","","{OM07}");
 addentry_menu(object_handle,"objectfront","object_flags","","","{OM08}");
 addentry_menu(object_handle,"objectback","object_flags","","","{OM09}");
 addentry_menu(object_handle,"snaptogrid","object_flags","","","{OM10}");
}

/****************************************************************/

void create_valign_menu(void)
{
 valign_handle=create_menu("{VAM00}");

 addentry_menu(valign_handle,"valign_entry","valign_flags","","","{VAM01}");
 addentry_menu(valign_handle,"valign_entry","valign_flags","","","{VAM02}");
 addentry_menu(valign_handle,"valign_entry","valign_flags","","","{VAM03}");
 addentry_menu(valign_handle,"valign_entry","valign_flags","","","{VAM04}");
}


/****************************************************************/

void create_firstline_menu(void)
{
 firstline_handle=create_menu("{FB04}");

 addentry_menu(firstline_handle,"firstline_entry","firstline_flags","","","{FB00}");
 addentry_menu(firstline_handle,"firstline_entry","firstline_flags","","","{FB01}");
 addentry_menu(firstline_handle,"firstline_entry","firstline_flags","","","{FB02}");
 addentry_menu(firstline_handle,"firstline_entry","firstline_flags","","","{FB03}");
}


/****************************************************************/

void create_guidewidth_menu(void)
{
 guidewidth_handle=create_menu("{GWM00}");

 addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");ugwidth0=0;
 addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");ugwidth1=709;
 addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");ugwidth2=1417;
 addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");ugwidth3=2834;
 addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");ugwidth4=5669;
 addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");ugwidth5=11338;
// addentry_menu(guidewidth_handle,"guidewidth_entry","guidewidth_flags","","","");
}

/****************************************************************/

void create_linewidth_menu(void)
{
 linewidth_handle=create_menu("{LWM00}");

 addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");lwidth0=0;
 addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");lwidth1=709;
 addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");lwidth2=1417;
 addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");lwidth3=2834;
 addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");lwidth4=5669;
 addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");lwidth5=11338;
// addentry_menu(linewidth_handle,"linewidth_entry","linewidth_flags","","","");
}

/****************************************************************/

void create_linestyle_menu(void)
{
 linestyle_handle=create_menu("{LSM00}");

 addentry_menu(linestyle_handle,"linestyle_entry","linestyle_flags","","","{LSM01}");
 addentry_menu(linestyle_handle,"linestyle_entry","linestyle_flags","","","{LSM02}");
 addentry_menu(linestyle_handle,"linestyle_entry","linestyle_flags","","","{LSM03}");
 addentry_menu(linestyle_handle,"linestyle_entry","linestyle_flags","","","{LSM04}");
 addentry_menu(linestyle_handle,"linestyle_entry","linestyle_flags","","","{LSM05}");
}

/****************************************************************/

void create_linejoin_menu(void)
{
 linejoin_handle=create_menu("{LJM00}");

 addentry_menu(linejoin_handle,"linejoin_entry","linejoin_flags","","","{LJM01}");
 addentry_menu(linejoin_handle,"linejoin_entry","linejoin_flags","","","{LJM02}");
 addentry_menu(linejoin_handle,"linejoin_entry","linejoin_flags","","","{LJM03}");
}

/****************************************************************/

void create_linestartcaps_menu(void)
{
 linestartcaps_handle=create_menu("{CSM00}");

 addentry_menu(linestartcaps_handle,"sc_entry","sc_flags","","","{CSM01}");
 addentry_menu(linestartcaps_handle,"sc_entry","sc_flags","","","{CSM02}");
 addentry_menu(linestartcaps_handle,"sc_entry","sc_flags","","","{CSM03}");
 addentry_menu(linestartcaps_handle,"sc_entry","sc_flags","caps_menu","","{CSM04}");
}

/****************************************************************/

void create_lineendcaps_menu(void)
{
 lineendcaps_handle=create_menu("{CEM00}");

 addentry_menu(lineendcaps_handle,"ec_entry","ec_flags","","","{CEM01}");
 addentry_menu(lineendcaps_handle,"ec_entry","ec_flags","","","{CEM02}");
 addentry_menu(lineendcaps_handle,"ec_entry","ec_flags","","","{CEM03}");
 addentry_menu(lineendcaps_handle,"ec_entry","ec_flags","caps_menu","","{CEM04}");
}

/****************************************************************/

void create_caps_menu(void)
{
 caps_handle=create_menu("{CPM00}");

 addentry_menu(caps_handle,"","","trianglew_menu","","{CPM01}");
 addentry_menu(caps_handle,"","","triangleh_menu","","{CPM02}");
}

/****************************************************************/

void create_trianglew_menu(void)
{
 trianglew_handle=create_menu("{TWM00}");

 addentry_menu(trianglew_handle,"triangle_entry","trianglew_flags","","","");umult0=0x10000;
 addentry_menu(trianglew_handle,"triangle_entry","trianglew_flags","","","");umult1=0x20000;
 addentry_menu(trianglew_handle,"triangle_entry","trianglew_flags","","","");umult2=0x30000;
 addentry_menu(trianglew_handle,"triangle_entry","trianglew_flags","","","");umult3=0x40000;
// addentry_menu(trianglew_handle,"triangle_entry","trianglew_flags","","","");
}

/****************************************************************/

void create_triangleh_menu(void)
{
 triangleh_handle=create_menu("{THM00}");

 addentry_menu(triangleh_handle,"triangle_entry","triangleh_flags","","","");umult0=0x10000;
 addentry_menu(triangleh_handle,"triangle_entry","triangleh_flags","","","");umult1=0x20000;
 addentry_menu(triangleh_handle,"triangle_entry","triangleh_flags","","","");umult2=0x30000;
 addentry_menu(triangleh_handle,"triangle_entry","triangleh_flags","","","");umult3=0x40000;
// addentry_menu(triangleh_handle,"triangle_entry","triangleh_flags","","","");
}

/****************************************************************/

void create_page_menu(void)
{
 page_handle=create_menu("{PGM00}");

 addentry_menu(page_handle,"page_entry","page_flags","","CS_C","{PGM01}");
 addentry_menu(page_handle,"openpageguidebox","page_flags","","","{PGM02}");
 addentry_menu(page_handle,"","","newchapter_menu","","{PGM03}");
 addentry_menu(page_handle,"openmodchapterbox","page_flags","","","{PGM04}");
 addentry_menu(page_handle,"copychapter","page_flags","","","{PGM09}");
 addentry_menu(page_handle,"","page_flags","pastechapter_menu","","{PGM0A}");
 addentry_menu(page_handle,"deletechapter","page_flags","","","{PGM05}");
 addentry_menu(page_handle,"openinspagebox","page_flags","","","{PGM06}");
 addentry_menu(page_handle,"opendelpagebox","page_flags","","","{PGM07}");
 addentry_menu(page_handle,"opengotopagebox","","","C_G","{PGM08}");
}

/****************************************************************/

void create_newpagesize_menu(void)
{
 newpagesize_handle=create_menu("{PSM00}");

 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM01}");
 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM02}");
 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM03}");
 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM04}");
 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM05}");
 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM06}");
 addentry_menu(newpagesize_handle,"newpagesize_entry","newpagesize_flags","","","{PSM07}");
}

/****************************************************************/

void create_newchapter_menu(void)
{
 newchapter_handle=create_menu("{CHM00}");

 addentry_menu(newchapter_handle,"newchapter_entry","","","","{CHM01}");
 addentry_menu(newchapter_handle,"newchapter_entry","","","","{CHM02}");
}



/****************************************************************/



void create_pastechapter_menu(void)
{
 pastechapter_handle=create_menu("{CHM03}");

 addentry_menu(pastechapter_handle,"pastechapter_entry","","","","{CHM04}");
 addentry_menu(pastechapter_handle,"pastechapter_entry","","","","{CHM05}");
}


/****************************************************************/

void create_misc_menu(void)
{
 misc_handle=create_menu("{MIM00}");

 addentry_menu(misc_handle,"","","spell_menu","","{MIM01}");
 addentry_menu(misc_handle,"opencharsbox","misc_flags","","F11","{MIM02}");
 addentry_menu(misc_handle,"","","insert_menu","","{MIM03}");
// addentry_menu(misc_handle,"","","","C_T","{MIM04}");
 addentry_menu(misc_handle,"openprefbox","","","CS_P","{MIM05}");
 addentry_menu(misc_handle,"misc_entry","","","","{MIM06}");
 addentry_menu(misc_handle,"flushundobuffer","misc_flags","","","{MIM10}");
// addentry_menu(misc_handle,"opencontentsbox","","","","{MIM07}");
// addentry_menu(misc_handle,"openindexbox","","","","{MIM08}");
 addentry_menu(misc_handle,"openmacrobox","","","","{MIM09}");
 addentry_menu(misc_handle,"openchoicesbox","","","","{IBM04}");
 addentry_menu(misc_handle,"openfontman","","","","{MIM11}");
}

/****************************************************************/

void create_spell_menu(void)
{
 spell_handle=create_menu("{SPM00}");

 addentry_menu(spell_handle,"spell_entry","spell_flags","","","{SPM01}");
 addentry_menu(spell_handle,"checkword","spell_flags","","C_W","{SPM02}");
 addentry_menu(spell_handle,"checkdocument","","","","{SPM03}");
 addentry_menu(spell_handle,"spell_entry","spell_flags","","","{SPM04}");
 addentry_menu(spell_handle,"spell_entry","spell_flags","","","{SPM05}");
 addentry_menu(spell_handle,"opendictionarybox","","","","{SPM06}");
}


/****************************************************************/

void create_dc_menu(void)
{
 dc_handle=create_menu("{SPD00}");

 addentry_menu(dc_handle,"openimportwordsbox","","","","{SPD01}");
 addentry_menu(dc_handle,"openexportwordsbox","","","","{SPD02}");
}


/****************************************************************/

void create_insert_menu(void)
{
 insert_handle=create_menu("{IM00}");

 addentry_menu(insert_handle,"insert_entry","insert_flags","","","{IM01}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","","{IM02}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","C_D","{IM03}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","","{IM04}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","","{IM05}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","C_Return","{IM06}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","S_Return","{IM07}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","C_SPACE","{IM08}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","CS_-","{IM09}");
 addentry_menu(insert_handle,"insert_entry","insert_flags","","C_-","{IM10}");
 addentry_menu(insert_handle,"openmergebox","insert_flags","","CS_M","{IM11}");
 addentry_menu(insert_handle,"openspacebox","insert_flags","","","{IM12}");
}

/****************************************************************/

void create_units_menu(void)
{
 units_handle=create_menu("{UM00}");

 addentry_menu(units_handle,"units_entry","units_flags","","","{UM01}");
 addentry_menu(units_handle,"units_entry","units_flags","","","{UM02}");
 addentry_menu(units_handle,"units_entry","units_flags","","","{UM03}");
}

/****************************************************************/

void create_colourchart_menu(void)
{
 int    i;
 string s;

 colourchart_handle=create_menu("{CCM00}");

 i=0;
 while(getcolourchart(i++,s))
  addentry_menu(colourchart_handle,"colourchart_entry","colourchart_flags","","",s);
}


/****************************************************************/


void create_chars_menu(void)
{
 int    i;
 string s;

 charselection_handle=create_menu("{CCM00}");

 i=0;
 while(getcharselection(i++,s))
  addentry_menu(charselection_handle,"charselection_entry","charselection_flags","","",s);
}



/****************************************************************/

void create_info_menu(void)
{
 info_handle=create_menu("{IBM00}");

 addentry_menu(info_handle,"openinfobox","","","","{ABOUTM}");
 addentry_menu(info_handle,"openregbox","","","","{REGM}");
 addentry_menu(info_handle,"info_entry","","","","{HELPM}");
 addentry_menu(info_handle,"helpwhatsthis","","","S_F1","{HELPW}");
}

/****************************************************************/

void main(void)
{
 create_main_menu();
 create_file_menu();
 create_edit_menu();
 create_view_menu();
 create_text_menu();
 create_case_menu();
 create_tint_menu();
 create_ulinewidth_menu();
 create_size_menu();
 create_effx_menu();
 create_bullet_menu();
 create_align_menu();
 create_lead_menu();
// create_rulewidth_menu();
 create_picture_menu();
 create_scope_menu();
 create_object_menu();
 create_valign_menu();
 create_firstline_menu();
 create_guidewidth_menu();
 create_linewidth_menu();
 create_linestyle_menu();
 create_linejoin_menu();
 create_linestartcaps_menu();
 create_lineendcaps_menu();
 create_caps_menu();
 create_trianglew_menu();
 create_triangleh_menu();
 create_page_menu();
 create_newpagesize_menu();
 create_newchapter_menu();
 create_pastechapter_menu();
 create_misc_menu();
 create_spell_menu();
 create_dc_menu();
 create_insert_menu();
 create_units_menu();
 create_colourchart_menu();
 create_chars_menu();
 create_info_menu();
 script_menu_initialise();
}
