/*->h.view */


#define HPBORDER 4800
#define VPBORDER 0


#define VBCLICKS    0x4
#define VBCLICKM    0x2
#define VBCLICKA    0x1

#define VBDRAGS     0x40
#define VBDRAGM     0x20 /*0x20's never happen, but don't confuse with 0x2's */
#define VBDRAGA     0x10

#define VBDBLCLICKS 0x400
#define VBDBLCLICKM 0x200
#define VBDBLCLICKA 0x100

#define VBLONGCLICKS 0x40000
#define VBLONGCLICKM 0x20000
#define VBLONGCLICKA 0x10000

#define VBTRIPCLICKS 0x400000
#define VBTRIPCLICKM 0x200000
#define VBTRIPCLICKA 0x100000

#define VBQUADCLICKS 0x4000000
#define VBQUADCLICKM 0x2000000
#define VBQUADCLICKA 0x1000000

#define VBPENTCLICKS 0x40000000
#define VBPENTCLICKM 0x20000000
#define VBPENTCLICKA 0x10000000



#define VBKEYMASK   0xF000
#define VBSHIFT     0x1000
#define VBCTRL      0x2000
#define VBALT       0x4000


#define VBDRAGCS    (VBCTRL |VBDRAGS)
#define VBDRAGSS    (VBSHIFT|VBDRAGS)

#define VBCLICKSS   (VBSHIFT|VBCLICKS)
#define VBCLICKCS   (VBCTRL |VBCLICKS)

#define VBCLICKCA   (VBCTRL |VBCLICKA)
#define VBCLICKSA   (VBSHIFT |VBCLICKA)

#define VBDRAGCA    (VBCTRL |VBDRAGA)
#define VBDRAGSA    (VBSHIFT|VBDRAGA)


extern filestr * menufile;
extern viewstr * menuview;

extern viewdatastr defviewdata;

extern int longclick;


extern viewstr * getmenuview(void);


extern int bosunits(int ourunits);
extern int osunits(int ourunits,viewstr * view);
extern int bourunits(int osunits);
extern int ourunits(int osunits,viewstr * view);
extern int dosunits(int osunits);
extern int dourunits(int ourunits,viewstr * view);


extern void getdrtr(transformstr * tr,transformstr * itr,viewredrawstr * v);


extern os_error * createnewprintview(viewstr ** viewp,filestr * file,
                                                      int master);
extern os_error * deleteview(viewstr * view,filestr * file);


extern os_error * createnewview(filestr * file,int branch,
                                               windowstr * window,int handle);

extern void       newview(int fp);
extern int        ismasterview(int fp);
extern int        view_handle(int fp);

extern int        nextview(int fp);

extern int userfiles(void);

extern os_error * updateviewdata(viewstr * view);
extern void       defaultviewdata(filestr * file);

extern void setviewscalefactor(viewstr * view);

extern os_error * refreshview(viewstr * view);
extern os_error * refreshfile(filestr * file);
extern os_error * refreshall(void);
extern os_error * viewrefreshallmenubars(void);


extern void updateviewtitle(viewstr * view);
extern void updatealltitles(filestr * file);



extern int  getguides(int fp);
extern void setguides(int fp);
extern void toggleguides(viewstr * view);

extern int  getmargins(int fp);
extern void setmargins(int fp);
extern void togglemargins(viewstr * view);

extern int  getpictures(int fp);
extern void setpictures(int fp);

extern int  getdouble(int fp);
extern void setdouble(int fp);

extern int  getinvisibles(int fp);
extern void setinvisibles(int fp);
extern void toggleinvisibles(viewstr * view);

extern int  getpasteboard(int fp);
extern void setpasteboard(int fp);

extern int  dcsfile(int fp);

extern void viewrepaint(int fp);


extern os_error * viewimport(char * name,int type,viewstr * view);
extern os_error * transview(int postflags,char * loadname,int loadtype,int loadvolatile,posnstr * loadposn,int transflags);


extern os_error * closefile(filestr * nextfile);
extern void       closeallfiles(void);

extern os_error * scrapviews(filestr * file);

extern viewstr * findview(int handle);
extern viewstr * file1view(filestr * file,viewstr * menuview);

extern os_error * validview(viewstr * target);

extern os_error * closemasterviews(filestr * file);
extern os_error * openmasterview(filestr * file);

extern os_error * closeviews(viewstr * view,filestr * file);

extern os_error * viewinit(void);

