/*->h.viewr */


typedef os_error * (*vredrawfn)(viewredrawstr * v);

typedef struct vlayerstr
{
 int        n;  /* layer number */
 vredrawfn fn;

} vlayerstr;


extern os_error * viewaddlayer(vlayerstr * vl);

extern os_error * viewredraw(int handle,int userhandle);

extern os_error * viewrefreshsobject(viewredrawstr * v,aboxstr * bbox,
                                                       transformstr * tr);

extern os_error * viewrefreshobject(int object,int section,int page,
                                                               filestr * file);

extern os_error * viewrefreshareas(filestr * file,viewredrawstr * v,int layer);
extern os_error * viewrefresharea(filestr * file,int page,
                                            aboxstr * abox,int layer);

extern os_error * viewrefreshaarea(viewstr * view,aboxstr * abox,int layer);

extern os_error * viewrefreshview(viewstr * view,int layer);
extern os_error * viewrefreshall(filestr * file,int branch,int layer);

extern os_error * vxstart(filestr * file);
extern os_error * vxend(filestr * file,int layer,int page,int section);
extern os_error * vxadd(sobjectstr ** sob,filestr * file);

extern os_error * vxstartn(filestr * file,int page,int section,int n);
extern os_error * vxendn(int layer);
extern os_error * vxaddn(sobjectstr ** sob,filestr * file,int page);

extern os_error * vxscrap(void);
extern os_error * vxflushn(int layer);
extern os_error * vxflush(filestr * file,int layer,int page,int section);

extern os_error * vxgetareas(viewredrawstr * v,int * sboxn,sboxstr *** sboxp);



#define VPPREV 0x8


extern os_error * viewrefreshpageplus(int page,int section,
                                               int branch,filestr * file);


extern int setcoords(viewredrawstr * v,int xpage);


extern void firstxcoord(viewredrawstr * v);
extern void nextxcoord(viewredrawstr * v);
extern void setxcoord(viewredrawstr * v);
extern void nextycoord(viewredrawstr * v);
extern void setycoord(viewredrawstr * v);

extern int boxinredraw(viewredrawstr * v,boxstr * box);

extern os_error * getpagecoords(viewstr * view,int page,int section,
                                                 int * xps,int * yps);


extern os_error * vxcadd(viewredrawstr * v,int object,int sub,int content,
                                       aboxstr * obox,aboxstr * sbox);

extern os_error * vxcrem(viewstr * view,int object,int sub);
extern os_error * vxcget(viewstr * view,int object,int sub,int n,
                                                          aboxstr ** sbox);
extern os_error * vxcclose(viewstr * view);
extern os_error * vxcrefresh(viewstr * view);
extern os_error * vxcopen(viewstr * view);
extern os_error * vxcflush(filestr * file,int content,int * object,int * sub);
extern os_error * vxcclear(filestr * file,int object,int sub);

extern void initviewredraw(viewredrawstr * v);
